import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class provides basic movement methods to its child classes.
 * 
 * @author Blake Hair
 * @version 6/14/11
 */
public abstract class Mover  extends Interactor
{
    public int speed;
    public void moveRight() 
    {
        setLocation(getX() + speed, getY());
    }
    
    public void moveLeft()
    {
        setLocation(getX() - speed, getY());
    }

    public void moveUp()
    {
        setLocation(getX(), getY() - speed);
    }
    
    public void moveDown()
    {
        setLocation (getX(), getY() + speed);
    }
    
    /**
     * Move a specified distance forward in the current direction.
     */
    public void move(double distance)
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * distance);
        int y = (int) Math.round(getY() + Math.sin(angle) * distance);
        
        setLocation(x, y);
    }
    public boolean checkEdgeWorld(){
        WheeWorld world = (WheeWorld)getWorld();
        if(getY() <=1 || getY() >= 399 || getX() <= 0 || getX() >= 599){
            return true;
        }
        return false;
    }
}
