import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;
/**
 * Write a description of class theWorld here.
 * 
 * @author Brandon Jones
 * @version TODAY'S
 */
public class WheeWorld  extends World
{
    Ted player;
    int currentLevel;
    public boolean gameOver = false;
    boolean spawnCHKPT = true;
    GreenfootSound backgroundMusic = new GreenfootSound("backgroundMusic.wav");
    GreenfootSound winSound = new GreenfootSound("winMusic.wav");
    
    /**
     * Constructor for objects of class theWorld.
     * 
     */
    public WheeWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        player = new Ted();
        setPaintOrder(Light.class, Ted.class, Ground.class, Checkpoint.class, Flame.class,
                      Spike.class, HelpSign.class);
        Greenfoot.setSpeed(48);
        populate(0); 
        backgroundMusic.playLoop();
    }
    public WheeWorld(boolean checkPoints)
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        player = new Ted();
        setPaintOrder(Light.class, Ted.class, Ground.class, Checkpoint.class, Flame.class,
                      Spike.class, HelpSign.class);
        spawnCHKPT = false;
        Greenfoot.setSpeed(48);
        populate(0); 
        backgroundMusic.playLoop();
    }
    public void clearLevel(){
        removeObjects(getObjects(Ground.class));
        removeObjects(getObjects(Reversal.class));
        removeObjects(getObjects(HelpSign.class));
        removeObjects(getObjects(Enemy.class));
        removeObjects(getObjects(Checkpoint.class));
        removeObjects(getObjects(AIFlag.class));
        removeObjects(getObjects(Light.class));
    }
    public void setCheckpointActive(int i){
        List<Checkpoint> chkpts = getObjects(Checkpoint.class); 
        for(int z = 0; z < chkpts.size(); z++){
            Checkpoint chkpt = chkpts.get(z);
            chkpt.checkActive(i);
        }
    }
    public int getLevel(){
        return currentLevel;
    }
    //direction 0 = up, 1 = right, 2 = down, 3 = left.
    public void changeLevel(int direction){
        switch(direction){
            case 0: 
                player.setLocation(player.getX(), 398); 
                break;
            case 1: 
                player.setLocation(2, player.getY());
                break;
            case 2:
                player.setLocation(player.getX(), 2);
                break;
            case 3:
                player.setLocation(598, player.getY());
                break;
        }
        populate(determineLevel(direction));
    }
    
    public int determineLevel(int direction){
        int ret = 0;
        switch(direction){
            case 0: //Up
                switch(currentLevel){
                    case 6:
                        ret = 5;
                        break;
                    case 7:
                        ret = 6;
                        break;
                    case 9:
                        ret = 3;
                        break;
                    case 10:
                        ret = 9;
                        break;
                    case 12:
                        ret = 11;
                        break;
                    case 14:
                        ret = 15;
                        break;
                    case 15:
                        ret = 0;
                        break;
                }
                break;
            case 1: //Right
                switch(currentLevel){
                    case 0:
                        ret = 1;
                        break;
                    case 1:
                        ret = 2;
                        break;
                    case 2:
                        ret = 3;
                        break;
                    case 3:
                        ret = 4;
                        break;
                    case 4:
                        ret = 5;
                        break;
                    case 8:
                        ret = 6;
                        break;
                    case 9: 
                        ret = 8;
                        break;
                    case 11:
                        ret = 9;
                        break;
                    case 13:
                        ret = 12;
                        break;
                    case 14:
                        ret = 13;
                        break;
                    case 16:
                        ret = 14;
                        break;
                }
                break;
            case 2: //Down
                switch(currentLevel){
                    case 0:
                        ret = 15;
                        break;
                    case 3:
                        ret = 9;
                        break;
                    case 5:
                        ret = 6;
                        break;
                    case 6:
                        ret = 7;
                        break;
                    case 9:
                        ret = 10;
                        break;
                    case 11:
                        ret = 12;
                        break;
                    case 15:
                        ret = 14;
                        break;
                }
                break;   
           case 3: //Left
                switch(currentLevel){
                    case 1:
                        break;
                    case 2:
                        ret = 1;
                        break;
                    case 3:
                        ret = 2;
                        break;
                    case 4:
                        ret = 3;
                        break;
                   case 5:
                        ret = 4;
                        break;
                   case 6:
                        ret = 8;
                        break;
                   case 8:
                        ret = 9;
                        break;
                   case 9:
                        ret = 11;
                        break;
                   case 12:
                        ret = 13;
                        break;
                   case 13:
                        ret = 14;
                        break;
                   case 14:
                        ret = 16;
                        break;
                   case 16:
                        ret = 20;
                        break;
                }
                break;
        }
        return ret;
    }
    public void populate(int level){
        clearLevel();
        switch(level){
            case 0: zero(); break;
            case 1: one(); break;
            case 2: two(); break;
            case 3: three(); break;
            case 4: four(); break;
            case 5: five(); break;
            case 6: six(); break;
            case 7: seven(); break;
            case 8: eight(); break;
            case 9: nine(); break;
            case 10: ten(); break;
            case 11: eleven(); break;
            case 12: twelve(); break;
            case 13: thirteen(); break;
            case 14: fourteen(); break;
            case 15: fifteen(); break;
            case 16: sixteen(); break;
            case 20: winScreen(); break;
        }
        if(!gameOver){
            setCheckpointActive(player.getCPID());
        }
    }
    private void winScreen(){
        gameOver = true;
        int deathCount = player.deathCount;
        removeObject(player);
        backgroundMusic.stop();
        winSound.play();
        Greenfoot.setWorld(new WinMenu(deathCount));
    }
    
    /*************************************************************************
     * 
     * 
     * LEVEL DEFINITIONS BELOW
     * 
     * 
     *************************************************************************/
    
    private void zero(){
        currentLevel = 0;
        addObject(player, 80,282);
        Color d = new Color(89, 89, 89);
        
        addObject(new Checkpoint(0, true), 81, 289); //Checkpoint #0 is on bottom.
        
        addObject(new Ground(225, 85, d), 110, 357);//left-side Ground.
        addObject(new Ground(10, 285, d), 5, 172);//left wall.
        addObject(new Ground(600, 30, d), 300, 15);//top-side Ground.
        addObject(new Ground(225, 85, d), 490, 357);//right-side Ground.
        
        
        //Reversals
        addObject(new Reversal(155, false), 300, 320);
    }
    
    private void one(){
        currentLevel = 1;
        Color d = new Color(145,99,19);
        //BOTTOM STAIRS
        
        addObject(new Ground(125, 40, d), 538, 380);
        addObject(new Ground(475, 85, d), 238, 357);
        addObject(new Ground(225, 40, d), 300, 295);
        addObject(new Ground(100, 40, d), 300, 255);
        
        
        //TOP STAIRS
        addObject(new Ground(600, 30, d), 300, 15);//top-side Ground.
        addObject(new Ground(375, 40, d), 300, 50);
        addObject(new Ground(225, 40, d), 300, 90);
        addObject(new Ground(100, 40, d), 300, 130);
        
        //Sign
        addObject(new HelpSign(), 60, 200);
        
    }
    private void two(){
        currentLevel = 2;
        Color d = new Color(6,104,142);
        
        //CEILING
        addObject(new Ground(600, 30, d), 300, 15);
        
        //CEILING SPIKE
        addObject(new Spike(2), 108, 43);
        addObject(new Spike(2), 178, 43);
        addObject(new Spike(2), 248, 43);
        addObject(new Spike(2), 409, 43);
        addObject(new Spike(2), 466, 43); 
        
        //Checkpoints
        if(spawnCHKPT){
        addObject(new Checkpoint(1, true), 33, 334);
        addObject(new Checkpoint(2, false), 551, 55);
       }
        
        //FLOOR
        addObject(new Ground(600, 40, d), 300, 380);
        
        //FLOOR SPIKES
        addObject(new Spike(0), 108, 348);
        addObject(new Spike(0), 165, 348);
        addObject(new Spike(0), 313, 348);
        addObject(new Spike(0), 369, 348);
        addObject(new Spike(0), 530, 348);
    }
    private void three(){
        currentLevel = 3;
        Color d = new Color(61,22,134);
        
        //CEILING
        addObject(new Ground(60, 30, d), 30, 15);
        addObject(new Ground(60, 30, d), 570, 15);
        
        //Floor
        addObject(new Ground(60, 40, d), 30, 380);
        addObject(new Ground(60, 40, d), 570, 380);
        
        //REFLECTOR BEAMS
        addObject(new Reversal(480, false), 300, 15);
        addObject(new Reversal(480, false), 300, 380);
        
        //FLOATING SPIKES
        addObject(new Spike(3), 182, 225);
        addObject(new Spike(3), 182, 155);
        addObject(new Spike(1), 207, 155);
        addObject(new Spike(1), 207, 225);        
        
        addObject(new Spike(3), 382, 225);
        addObject(new Spike(3), 382, 155);
        addObject(new Spike(1), 407, 155);
        addObject(new Spike(1), 407, 225);
        
        //CheckPoint
        if(spawnCHKPT)addObject(new Checkpoint(3, true), 571, 334);
    }
    private void four(){
        currentLevel = 4;
        Color d = new Color(16,139,16);
        
        //CEILING
        addObject(new Ground(600, 30, d), 300, 15);
        
        addObject(new Spike(2), 150, 41);
        addObject(new Spike(2), 220, 41);
        addObject(new Spike(2), 290, 41);
        addObject(new Spike(2), 360, 41);
        addObject(new Spike(2), 430, 41);
        
        //FLOOR
        addObject(new Ground(600, 40, d), 300, 380);
        
        addObject(new Spike(0), 150, 349);
        addObject(new Spike(0), 220, 349);
        addObject(new Spike(0), 290, 349);
        addObject(new Spike(0), 360, 349);
        addObject(new Spike(0), 430, 349);
        addObject(new Spike(0), 500, 349);
        addObject(new Spike(0), 557, 349);
        
        //Reversals
        addObject(new Reversal(330, true), 155, 191);
        addObject(new Reversal(330, true), 280, 191);
        addObject(new Reversal(330, true), 405, 191);
        
        //Checkpoint
        if(spawnCHKPT)addObject(new Checkpoint(4, false), 568, 55);
        
    }
    private void five(){
        currentLevel = 5;
        Color d = new Color(207,205,1);
        
        //CEILING
        addObject(new Ground(600, 30, d), 300, 15);
        
        //FLOOR
        addObject(new Ground(80, 40, d), 40, 380);
        
        //WALL
        addObject(new Ground(10, 370, d), 595, 215);
        
        //Checkpoint
        if(spawnCHKPT)addObject(new Checkpoint(5, false), 552, 55);
    }
     private void six(){
        currentLevel = 6;
        Color d = new Color(207,205,1);
        
        //CEILING
        addObject(new Ground(80, 10, d), 40, 5);
        
        //FLOOR
        addObject(new Ground(80, 240, d), 40, 280);
        
        //WALL
        addObject(new Ground(10, 400, d), 595, 200);
        
        //Checkpoint
        if(spawnCHKPT)addObject(new Checkpoint(6, true), 39, 134);
        
        //Enemy
        addObject(new Flame(6), 570, 177);
        addObject(new AIFlag(), 570, 177);
    }
    
    private void seven(){
        currentLevel = 7;
        Color d = new Color(0,0,30);
        
        //FLOOR
        addObject(new Ground(80, 400, d), 40, 200);
        addObject(new Destructible(130, 20, Color.darkGray, 0.05), 525, 353); 
        
        //WALL
        addObject(new Ground(10, 400, d), 595, 200);
        
        //SPIKES
        addObject(new Spike(0), 114, 392);
        addObject(new Spike(0), 184, 392);
        addObject(new Spike(0), 254, 392);
        addObject(new Spike(0), 324, 392);
        addObject(new Spike(0), 394, 392);
        addObject(new Spike(0), 464, 392);
        addObject(new Spike(0), 534, 392);
        addObject(new Spike(0), 562, 392);
    }
    
    private void eight(){
        currentLevel = 8;
        Color d = new Color(16,139,16);
        
        //Ground and Walls
        addObject(new Ground(600, 10, d), 300, 5);
        addObject(new Ground(40, 240, d), 580, 280);
        addObject(new Ground(40, 150, d), 20, 85);
        addObject(new Ground(350, 10, d), 385,165);
        addObject(new Ground(40, 40, d), 440, 270);
        addObject(new Ground(560, 10, d), 280, 395);
       
        
        //Fireball and Flags
        addObject(new Flame(), 120, 165);
        addObject(new AIFlag(), 225, 165);
        addObject(new AIFlag(), 25, 165);
        
        addObject(new Flame(90, 3), 290, 290);
        addObject(new AIFlag(), 290, 400);
        addObject(new AIFlag(), 290, 155);
        
        addObject(new Spike(1), 48, 109);
        addObject(new Spike(1), 15, 195);
        addObject(new Spike(1), 15, 237);
        addObject(new Spike(0), 165, 380);
        
        addObject(new Reversal(420, false), 210, 270);
        
        
       
    }
    
    private void nine(){
        currentLevel = 9;
        Color d = new Color(61,22,134);
        
        //Ground and walls
        addObject(new Ground(60, 160, d), 570, 80);
        addObject(new Ground(60, 10, d), 30, 5);
        addObject(new Ground(60, 10, d), 570, 395);
        addObject(new Ground(10, 310, d), 5, 280);
        addObject(new Ground(460, 10, d), 240, 130); 
        addObject(new Ground(40, 40, d), 100, 270);
        addObject(new Ground(10, 114, new Color(0,0,0)), 595, 217); //Back of spike in room 8.
        
        //Checkpoint
        if(spawnCHKPT){
        addObject(new Checkpoint(7, true), 570, 364);
        addObject(new Checkpoint(8, true), 30, 99);
       }
        
        //Spikes
        addObject(new Spike(0), 289, 257);
        addObject(new Spike(2), 289, 283);
        addObject(new Spike(0), 434, 111);
        addObject(new Spike(0), 250, 111);
        addObject(new Spike(2), 434, 148);
        addObject(new Spike(3), 575, 195);
        addObject(new Spike(3), 575, 237);
        
        //Reversal line.
        addObject(new Reversal(500, false), 350, 270);
        
    }
    
    private void ten(){
        currentLevel = 10;
        Color d = new Color(30,11,67);
        
        //Ground and Walls
        addObject(new Ground(60, 400, d), 570, 200);
        addObject(new Ground(10, 400, d), 5, 200);
        
        //Reversal
        addObject(new Reversal(530, false), 274, 370);
        
        //Enemies and AI Flags
        addObject(new Flame(45, 3), 507, 344); 
        addObject(new AIFlag(), 507, 344);
        
        addObject(new Flame(-45, 3), 165, 250);
        addObject(new AIFlag(), 289, 126);
        addObject(new AIFlag(), 75, 344);
        
        addObject(new Flame(), 209, 113);
        addObject(new AIFlag(), 260, 113);
        addObject(new AIFlag(), 25, 113);
        
        //Spikes
        addObject(new Spike(0), 289, 100);
        addObject(new Spike(2), 289, 126);
        addObject(new Spike(1), 23, 113);
        
    }
    
    private void eleven(){
        currentLevel = 11;
        Color d = new Color(6,104,142);
        Color destruct = new Color(12, 208, 255);
        
        //Ground and Walls
        addObject(new Ground(600, 10, d), 300, 5);
        addObject(new Ground(60, 80, d), 570, 165);
        addObject(new Ground(408,10, d), 336, 200);
        addObject(new Ground(450,10, d), 235, 395);
        addObject(new Ground(10, 390, d), 5, 205);
        addObject(new Ground(10, 200, d), 595, 300);
        
        //Destructible platforms.
        addObject(new Destructible(70,10, destruct, 0.04), 505, 163);
        addObject(new Destructible(70,10, destruct, 0.04), 435, 163);
        addObject(new Destructible(70,10, destruct, 0.04), 365, 163);
        addObject(new Destructible(70,10, destruct, 0.04), 295, 163);
        addObject(new Destructible(70,10, destruct, 0.04), 225, 163);
        addObject(new Destructible(70,10, destruct, 0.04), 142, 42);
        addObject(new Destructible(70,10, destruct, 0.04), 72, 42);
        addObject(new Destructible(70,10, destruct, 0.04), 72, 359);
        addObject(new Destructible(70,10, destruct, 0.04), 166, 242);
        addObject(new Destructible(70,10, destruct, 0.04), 236, 242);
        addObject(new Destructible(70,10, destruct, 0.04), 306, 242);
        addObject(new Destructible(70,10, destruct, 0.04), 376, 242);
        addObject(new Destructible(70,10, destruct, 0.04), 446, 242);
        addObject(new Destructible(70,10, destruct, 0.04), 516, 242);
        
        //Spikes top ceiling.
        addObject(new Spike(2), 504, 20);
        addObject(new Spike(2), 434, 20);
        addObject(new Spike(2), 364, 20);
        addObject(new Spike(2), 294, 20);
        addObject(new Spike(2), 224, 20);
        addObject(new Spike(2), 154, 20);
        addObject(new Spike(2), 84, 20);
        addObject(new Spike(2), 14, 20);
        
        //Spikes floor one.
        addObject(new Spike(0), 504, 183);
        addObject(new Spike(0), 434, 183);
        addObject(new Spike(0), 364, 183);
        addObject(new Spike(0), 294, 183);
        addObject(new Spike(0), 224, 183);
        addObject(new Spike(0), 167, 183);
        
        //Spikes bottom ceiling
        addObject(new Spike(2), 559, 216);
        addObject(new Spike(2), 504, 216);
        addObject(new Spike(2), 434, 216);
        addObject(new Spike(2), 364, 216);
        addObject(new Spike(2), 294, 216);
        addObject(new Spike(2), 224, 216);
        addObject(new Spike(2), 167, 216);
        
        //Spikes bottom floor.
        addObject(new Spike(0), 420, 380);
        addObject(new Spike(0), 364, 380);
        addObject(new Spike(0), 294, 380);
        addObject(new Spike(0), 224, 380);
        addObject(new Spike(0), 154, 380);
        addObject(new Spike(0), 84, 380);
        addObject(new Spike(0), 14, 380);
        
        //Spikes on left-side wall.
        addObject(new Spike(1), 20, 74);
        addObject(new Spike(1), 20, 144);
        addObject(new Spike(1), 20, 214);
        addObject(new Spike(1), 20, 284);
        addObject(new Spike(1), 20, 326);
        
    }
    
    private void twelve(){
        currentLevel = 12;
        Color d = new Color(3,52,71);
        
        //Ceiling and Ground
        addObject(new Ground(460,10, d), 230, 5);
        addObject(new Ground(10, 400, d), 595, 200);
        addObject(new Ground(225, 200, d), 477, 299);
        addObject(new Ground(225, 225, d), 113, 122);
        addObject(new Ground(366, 10, d), 183, 395);
        
        //Reversals
        addObject(new Reversal(190, true), 367, 104);
        addObject(new Reversal(190, true), 223, 305);
        
        //Spikes
        addObject(new Spike(2), 261, 24);
        addObject(new Spike(2), 331, 24);
        
        addObject(new Spike(1), 240, 74);
        addObject(new Spike(1), 240, 144);
        addObject(new Spike(1), 240, 199);
        
        addObject(new Spike(3), 350, 325);
        addObject(new Spike(3), 350, 255);
        addObject(new Spike(3), 350, 240);
        
        addObject(new Spike(0), 329, 375);
        addObject(new Spike(0), 259, 375);
        addObject(new Spike(0), 189, 375);
        addObject(new Spike(0), 119, 375);
        addObject(new Spike(0), 49, 375);
        addObject(new Spike(0), 35, 375);
        
        //Checkpoint
        if(spawnCHKPT)addObject(new Checkpoint(9, false), 80, 260); 
    }
    
    private void thirteen(){
        currentLevel = 13;
        Color d = new Color(73,50,10);
        Color destruct = new Color(110, 75, 15);
        
        //Ceiling and Ground
        addObject(new Ground(600, 10, d), 300, 5);
        addObject(new Ground(600, 10, d), 300, 395);
        addObject(new Ground(100, 225, d), 550, 122);
        addObject(new Ground(110, 175, d), 445, 97);
        addObject(new Ground(110, 125, d), 335, 72);
        addObject(new Ground(110, 75, d), 225, 47);
        addObject(new Ground(170, 25, d), 85, 22);
        
        //Lower Spikes
        addObject(new Spike(0), 562, 375);
        addObject(new Spike(0), 491, 375);
        addObject(new Spike(0), 420, 375);
        addObject(new Spike(0), 349, 375);
        addObject(new Spike(0), 278, 375);
        addObject(new Spike(0), 207, 375);
        addObject(new Spike(0), 136, 375);
        addObject(new Spike(0), 65, 375);
        addObject(new Spike(0), 36, 375);
        
        //Upper Spikes
        addObject(new Spike(2), 467, 199); 
        addObject(new Spike(2), 425, 199);
        addObject(new Spike(2), 356, 149);
        addObject(new Spike(2), 315, 149);
        addObject(new Spike(2), 246, 99);
        addObject(new Spike(2), 205, 99);
        addObject(new Spike(2), 136, 49);
        addObject(new Spike(2), 65, 49);
        addObject(new Spike(2), 36, 49);
        
        //Floating Destructible grounds.
        addObject(new Destructible(110, 10, destruct, 0.04), 446, 219);
        addObject(new Destructible(110, 10, destruct, 0.04), 335, 355);
        addObject(new Destructible(110, 10, destruct, 0.04), 226, 119);
        addObject(new Destructible(110, 10, destruct, 0.04), 115, 355);
        addObject(new Destructible(60, 10, destruct, 0.04), 30, 71);
    }
    
    private void fourteen(){
        currentLevel = 14;
        Color d = new Color(44, 44, 44);
        Color destruct = new Color(88, 88, 88);
        
        //Ceiling and Ground
        addObject(new Ground(600, 10, d), 300, 395);
        addObject(new Ground(210, 35, d), 494, 18);
        addObject(new Ground(210, 10, d), 106, 5);
        addObject(new Ground(20, 20, d), 300, 145);
        addObject(new Ground(20, 20, d), 175, 145);
        
        //Reversal
        addObject(new Reversal(125, false), 238, 145);
        
        //Destructible Ground
        addObject(new Destructible(110, 10, d, 0.02), 544, 70);
        addObject(new Destructible(100, 10, d, 0.02), 439, 70);
        addObject(new Destructible(100, 10, d, 0.02), 51, 44);
        addObject(new Destructible(110, 10, d, 0.02), 156, 44);
        
        //Floor Spikes
        addObject(new Spike(0), 562, 375);
        addObject(new Spike(0), 491, 375);
        addObject(new Spike(0), 420, 375);
        addObject(new Spike(0), 349, 375);
        addObject(new Spike(0), 278, 375);
        addObject(new Spike(0), 207, 375);
        addObject(new Spike(0), 136, 375);
        addObject(new Spike(0), 65, 375);
        addObject(new Spike(0), 36, 375);
        
        //Ceiling Spikes
        addObject(new Spike(2), 564, 49);
        addObject(new Spike(2), 494, 49);
        addObject(new Spike(2), 424, 49);
        addObject(new Spike(2), 35, 24);
        addObject(new Spike(2), 105, 24);
        addObject(new Spike(2), 175, 24);
    }
    
    private void fifteen(){
        currentLevel = 15;
        Color d = new Color(89, 89, 89);
        
        //Ground and Walls
        addObject(new Ground(225, 10, d), 490, 5);
        addObject(new Ground(225, 10, d), 110, 5);
        addObject(new Ground(210, 10, d), 494, 395);
        addObject(new Ground(210, 10, d), 106, 395);
        addObject(new Ground(15, 380, d), 8, 200);
        addObject(new Ground(15, 380, d), 593, 200);
        addObject(new Ground(70, 100, d), 50, 60);
        addObject(new Ground(70, 100, d), 551, 60);
        addObject(new Ground(70, 100, d), 50, 340);
        addObject(new Ground(70, 100, d), 551, 340);
        addObject(new Ground(70, 50, d), 120, 35);
        addObject(new Ground(70, 50, d), 481, 35);
        addObject(new Ground(70, 50, d), 120, 365);
        addObject(new Ground(70, 50, d), 481, 365);
        
        //Central obstacle
        addObject(new Ground(142, 54, d), 300, 200);
        
        //Top Spikes
        addObject(new Spike(2), 49, 124);
        addObject(new Spike(2), 118, 74);
        addObject(new Spike(2), 187, 24);
        addObject(new Spike(2), 413, 24);
        addObject(new Spike(2), 482, 74);
        addObject(new Spike(2), 552, 124);
        
        //Bottom Spikes
        addObject(new Spike(0), 49, 275);
        addObject(new Spike(0), 118, 325);
        addObject(new Spike(0), 175, 375);
        addObject(new Spike(0), 424, 375);
        addObject(new Spike(0), 482, 325);
        addObject(new Spike(0), 552, 275);
        
        //Center Spikes
        addObject(new Spike(0), 335, 165);
        addObject(new Spike(0), 266, 165);
        addObject(new Spike(2), 335, 232);
        addObject(new Spike(2), 266, 232);
        
        
    }
    
    private void sixteen(){
        currentLevel = 16;
        Color d = new Color(10,10,10);
        Color destruct = new Color(80,80,80);
        
        //Ground and Ceiling
        addObject(new Ground(71, 10, d), 564, 5);
        addObject(new Ground(71, 10, d), 564, 395);
        addObject(new Ground(529, 50, d), 264, 25);
        addObject(new Ground(529, 250, d), 264, 275);
        
        
        //Destructible Ground
        addObject(new Destructible(71, 10, destruct, 0.04), 564, 45);
        
        //Spikes
        addObject(new Spike(2), 564, 24);
        addObject(new Spike(0), 564, 376);
        
        //The Light at the End of the Tunnel
        addObject(new Light(), 38, 104);
        setPaintOrder(Ground.class,Light.class, Ted.class, Checkpoint.class, Flame.class,
                      Spike.class, HelpSign.class);
    }
}
