import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
/**
 * Write a description of class WinMenu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class WinMenu extends World implements ActionListener
{
    public static final Font LARGE_FONT = new Font("SansSerif", Font.BOLD, 20);
    public static final Font MED_FONT = new Font("SansSerif", Font.ITALIC, 14);
    public static final Font SMALL_FONT = new Font("SansSerif", Font.PLAIN, 10);
    
    private Button normalMode;
    private Button noChkptMode;
    private Label deathCountLabel;
    private Label playAgain;
    /**
     * Constructor for objects of class WinMenu.
     * 
     */
    
    public WinMenu(int deathCount)
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        
        String deathLabel = "You died " + deathCount + " time";
        if(deathCount == 1){
            deathLabel += ".";
        }
        else{
            deathLabel +="s.";
        }
        deathCountLabel = new Label(deathLabel);
        deathCountLabel.setFont(LARGE_FONT);
        
        playAgain = new Label("Play Again");
        playAgain.setFont(LARGE_FONT);
        
        //Play again in Normal Mode
        normalMode = new Button(new GreenfootImage("normal_bttn1.png"),
                                new GreenfootImage("normal_bttn3.png"),
                                new GreenfootImage("normal_bttn2.png"));
        normalMode.setID(1001);
        normalMode.addActionListener(this);
        
        //Play Again in No CheckPoint Mode
        noChkptMode = new Button(new GreenfootImage("chkpnt_bttn1.png"),
                                new GreenfootImage("chkpnt_bttn3.png"),
                                new GreenfootImage("chkpnt_bttn2.png"));
        noChkptMode.setID(1002);
        noChkptMode.addActionListener(this);
        
        //Add GUI Elements to world.
        addObject(normalMode, 72, 322);
        addObject(noChkptMode, 118, 360);
        addObject(deathCountLabel, 455, 28);
        addObject(playAgain, 78, 290);
    }
    
    public void actionPerformed(GUIComponent c){
        if(c.getID() == 1001){
            Greenfoot.setWorld(new WheeWorld());
        }
        else if(c.getID() == 1002){
            Greenfoot.setWorld(new WheeWorld(false));
        }
    }
}
